#include "colors.inc"

#ifdef (SIMPLE_TEXTURE)
#declare holder_texture = texture { pigment { Yellow } }
#declare red_wax = texture { pigment { Red} }
#else 

#declare holder_texture = texture {
	finish {
		ambient 0.15
		brilliance 8.0 
		diffuse 0.55
		specular 0.9
		roughness 0.05
		metallic
		reflection 0.85
	}
	pigment { rgb<0.988, 0.965, 0.65> }
}
#declare red_wax = texture { 
	pigment { Red }
	finish {
		diffuse 0.75
		brilliance 0.65
		specular 0.8
		roughness 0.032
	}
	normal {
		dents 0.05
		scale 0.1
	}
}

#end

#declare candle_holder = union { 
	lathe {
	cubic_spline
	18,
	<0,2>, <0.5, 2>, <0.5, 3>, <1,3>, <0.82, 2.85>, 
	<0.82, 2.5>, <0.7, 2.25>, <0.6, 2.0>, <0.5, 2>, <0.5, 0.5>, 
	<1, 0.25>, <2.75, 0.25>, <3.0, 0.5>, <3.25, 0.75>, <3.0, 0.25>,
	<2.75, 0>, <0, 0>, <0, 2>
	}
	torus { 
		0.75, 0.125
		rotate < 0 , 0 , 90 >
		translate < 0, 1.0, 3.75 >
	}
	rotate < 0, 45, 0 >
	texture { holder_texture }
}

#declare candle = union {
	difference {
		cylinder {
			<0,0,0>, <0,candle_ht,0>, 0.5
			texture { red_wax }
		}
		sphere {
			<0,candle_ht+0.9,0>, 1
			pigment {White} 
		}
	}
	cylinder {
		<0,candle_ht-0.1,0>, <0.1,candle_ht+0.2,0>, 0.05
		pigment{ Black }
	}
}
#declare flame = merge {
	intersection {
		sphere { <0,0,0>,1 }
		plane { -y, 0 }
		scale <1,1.75,1>
		translate <0,-0.75,0>
	}
	intersection {
		sphere { <0,0,0>,1 }
		plane { y, 0 }
		scale <1,0.25,1>
		translate <0,-0.75,0>
	}
	hollow
	pigment { rgbf<1,1,1,1> }
	halo {
		emitting
		spherical_mapping
		max_value 1
		cubic
		color_map {
			[ 0 rgbt <0.8,0.8,0.58,0.24> ]
			[ 0.45 rgbt <0.8,0.8,0.58,0.1> ]
			[ 0.45 rgbt <0,0,1,0.1> ]
			[ 0.65 rgbt <0,0,1,0.9> ]
			[ 0.7 rgbt <0,0,1,1> ]
			[ 1 rgbt <0,0,1,1> ]
		}
		samples 20
		aa_threshold 0.3
		aa_level 3
		turbulence <0.25,0,0.25>
		translate <0,-1,0>
	}
	scale < 0.25, 1, 0.25> 
}


